/* Wrapper function - split search string into separate phrases and words */
function highlightSearchTerms(searchText)
{
  var bodyText = document.body.innerHTML;
  var colorNum = 0;

  if (!document.body || typeof(document.body.innerHTML) == "undefined") 
    return false;
  if (typeof(searchText) == "undefined") 
    searchText = getURLParameter("srch");

  // Highlight quoted phrases
  while (searchText.indexOf("\"") >= 0) {
    var qBegin = searchText.indexOf("\"");
    var qEnd   = searchText.indexOf("\"", qBegin+1);
    if (qEnd == -1) break;
    bodyText = doHighlight(bodyText, searchText.substring(qBegin+1, qEnd), colorNum%3);
    searchText = searchText.substring(0, qBegin-1) + searchText.substring(qEnd+1);
    colorNum++;
  }

  // Highlight remaining words
  while (searchText.substr(0,1) == " ") 
    searchText = searchText.substr(1);  // trim lead spaces
  var wordArray = searchText.split(" ");
  for (var i=0; i<wordArray.length; i++) {
    if (wordArray[i]) 
      bodyText = doHighlight(bodyText, wordArray[i], colorNum%3);
    colorNum++;
  }

  document.body.innerHTML = bodyText;
  return true;
}

/* Highlights a single word/phrase by adding HTML tags */
function doHighlight(bodyText, searchTerm, colorNum)
{
  var lcBodyText   = bodyText.toLowerCase();
  var lcSearchTerm = searchTerm.toLowerCase();
  var newText      = "";
  var i            = -1;

  while (bodyText.length > 0) {
    i = lcBodyText.indexOf(lcSearchTerm, i+1);
    if (i < 0) {
      newText += bodyText;
      bodyText = "";
    } else {
      // skip stuff inside HTML tags
      if (bodyText.lastIndexOf(">", i) >= bodyText.lastIndexOf("<", i))
        // skip stuff in <script> blocks
        if (lcBodyText.lastIndexOf("/script>", i) >= lcBodyText.lastIndexOf("<script", i)) {
          newText   += bodyText.substring(0, i) + 
                       "<span id=hilight" + colorNum + ">" + 
                       bodyText.substr(i, searchTerm.length) + 
                       "</span>";
          bodyText   = bodyText.substr(i + searchTerm.length);
          lcBodyText = bodyText.toLowerCase();
          i = -1;
        }
    }
  }
  return newText;
}

/* Get parameter from URL */
function getURLParameter(paramName) {
  var currentUrl = window.location.search;
  var paramBegin = currentUrl.indexOf(paramName) + (paramName.length+1);
  var paramEnd   = currentUrl.indexOf("&", paramBegin);
  if (paramEnd == -1) paramEnd = currentUrl.length;
  var paramValue = unescape( currentUrl.substring(paramBegin, paramEnd) );
  while (paramValue.indexOf("+") >= 0) paramValue = paramValue.replace("+", " ");
  return paramValue;
}

